#!/bin/bash

if [ "$#" -ne 1 ]; then
    echo "ERROR! Illegal number of parameters. Usage: bash install.sh conda_install_path"
    exit 0
fi

conda_install_path=$1

source $conda_install_path/etc/profile.d/conda.sh
echo "****************** Creating conda environment ******************"
conda env create -y -f env.yml

echo ""
echo ""
echo "****************** Activating conda environment ${conda_env_name} ******************"
conda activate cv3

mkdir pytracking/networks

echo ""
echo ""
echo "****************** Setting up environment ******************"
python -c "from pytracking.evaluation.environment import create_default_local_file; create_default_local_file()"
python -c "from ltr.admin.environment import create_default_local_file; create_default_local_file()"

echo ""
echo ""
echo "****************** Installation complete! ******************"
